heatmap <- function(mat.pval, mat.beta, pos_leg=c(0.65,0)){
  
## 0. Chargement des packages
library(gplots)
library(RColorBrewer)
library(lattice)
library(shape)
library(latticeExtra)
plot.new()
#frame()
#### --------------------------------------------------------------- ####
xmargin <- 0.2
ymargin <- 0.2 
topmargin <- 0.2
spaceticklab <- 1
ymargin2 <- 0.2
par(mar = c(xmargin, ymargin, topmargin, ymargin2), cex = 1.4, 
    mgp = c(3, spaceticklab, 0), las = 0)

# Leftmost position of the legend
pos_ref_x <- pos_leg[1]
# Bottommost position of the legend
pos_ref_y <- pos_leg[2]
# Width of individual colors in the legend
width_leg <- 0.05
# Height of the legend
height_leg <- 0.45
# Distance between the red and the blue
sep_leg=0.2

# Position of the red legend
posx_red=c(pos_ref_x,(pos_ref_x+width_leg))
posy_red=c(pos_ref_y,(pos_ref_y+height_leg))
zlim_red=c(0.119,0)
zval_red=c(0.1,0)

# Position of the blue legend
posx_blue=c( (pos_ref_x+sep_leg) ,(pos_ref_x+width_leg+sep_leg))
posy_blue=c(pos_ref_y,(pos_ref_y+height_leg))
zlim_blue=c(-0.119,0)
zval_blue=c(-0.1,0)


maincex1=2.5
cex1=1.35

legx=0.78
legy=0.62
legcex=1.6

# Note: it is necessary to have 2 matrices:
# - mat.pval
# - mat.beta
# The rows and columns in each need to have been properly identified with rownames and colnames


#mat.pval <- matrix(runif(9, min=0.01, max=0.25), nrow=3)
#mat.beta <- matrix(rnorm(9), nrow=3)
#mat.pval[1,1] <- 0.001

#rownames(mat.beta) <- rownames(mat.pval) <- c("A", "B", "C")
#colnames(mat.beta) <- colnames(mat.pval) <- c("X", "Y", "Z")

#### --------------------------------------------------------------- ####

## 1. Loading and formatting the matrices

# Intermediate matrix for levelplot

data_matrix <- sign(mat.beta) * mat.pval

# Define the color shadings (col1=blue, col2=red)
# Blue
col_breaks1 <- unique(c(seq(-0.1,-0.25,length=1), seq(-0.1,0,length=100), seq(0,0.25,length=1)))
my_palette1 <- colorRampPalette(c("NA", "blue4"))(n=102)
# Red
col_breaks2 <-  unique(c(seq(0,0.1,length=100), seq(0.1,0.25,length=1)))
my_palette2 <- colorRampPalette(c("red4", "NA"))(n = 101)

# Colours used for the colorkeys

col1 <- colorRampPalette(c("white","blue4"))(n=100)  #blue4  #navyblue
col2 <- colorRampPalette(c("white","red4"))(n=100)   #red4   #darkred

# Remove the outside border of the heatmap

lattice.options(axis.padding=list(factor=0.5))

# Layout utilis? sous forme d'une matrice 1X4

par(mfrow=c(1,3))

# Producing the heatmap  ----> required packages: lattice et latticeExtra

nlignes <- nrow(data_matrix)
ncol1<- ncol(data_matrix)
ratio=ncol1/nlignes

print(nlignes)
print(ncol1)

plot1 <- levelplot(t(data_matrix[nlignes:1,]),border = "black",           
                   region=T,col.regions=my_palette1,
                   pretty=F,xlab='',ylab='',main="",
                   at=col_breaks1,colorkey=FALSE,
                   scales=list(x=list(rot=90,alternating=2),cex=1.3))
plot2 <- levelplot(t(data_matrix[nlignes:1,]),border = "black",           
                   region=T,col.regions=my_palette2,
                   pretty=F,xlab='',ylab='',main="",
                   at=col_breaks2,colorkey=FALSE,
                   scales=list(x=list(rot=90,alternating=2),cex=1.3))


  print(plot1 + plot2)  #Superposition des 2 heatmaps avec le package latticeExtra
#print(plot1 + plot2,  position=c(0,0,0.5,0.5))  #Superposition des 2 heatmaps avec le package latticeExtra


# Parameters for plotting
#ref1=0.18*ncol1
#ref2=0.13*ncol1


# Colorkey blue (-) ---->package required: shape

colorlegend(posx = posx_blue,posy=posy_blue, left = TRUE, col = col1, 
            zlim = zlim_blue, digit = 1, zval= zval_blue,main='-',main.cex=maincex1,cex=cex1)

# Colorkey rouge (+) ---->package required: shape

colorlegend(posx = posx_red, posy=posy_red,left = TRUE, col = col2, 
            zlim = zlim_red, digit = 1, zval=zval_red,main='+', main.cex=maincex1,cex=cex1)

# Adding the word "Legend" above the colorkeys

#text(legx,legy , "Legend",cex = legcex)

}
